#include<Mouse.h>
#include<Keyboard.h>

char cmd[3 + 1];
unsigned long inChar;
int i;
int xReading;
int yReading;
int wReading;
int num;
int isMinus;
int moveDelta;

void setup() {
  Serial.begin(9600);
  Mouse.begin();
  Keyboard.begin();
  moveDelta = 10;
}

void loop() {
  int mouseState = 0;
  int keyboardState = 0;
  // check for incoming serial data:
  if (Serial.available() >= 3) {
    for (i = 0; i < 3; i++) {
      cmd[i] = Serial.read();
    }
    cmd[3] = '\0';
    if (strcmp(cmd, "MCL") == 0) {
      Mouse.click(MOUSE_LEFT);
    } else if (strcmp(cmd, "MCR") == 0) {
      Mouse.click(MOUSE_RIGHT);
    } else if (strcmp(cmd, "MCM") == 0) {
      Mouse.click(MOUSE_MIDDLE);
    } else if (strcmp(cmd, "MPL") == 0) {
      Mouse.press(MOUSE_LEFT);
    } else if (strcmp(cmd, "MPR") == 0) {
      Mouse.press(MOUSE_RIGHT);
    } else if (strcmp(cmd, "MPM") == 0) {
      Mouse.press(MOUSE_MIDDLE);
    } else if (strcmp(cmd, "MPL") == 0) {
      Mouse.release(MOUSE_LEFT);
    } else if (strcmp(cmd, "MPR") == 0) {
      Mouse.release(MOUSE_RIGHT);
    } else if (strcmp(cmd, "MPM") == 0) {
      Mouse.release(MOUSE_MIDDLE);
    } else if (strcmp(cmd, "MSL") == 0) {
      mouseState = Mouse.isPressed(MOUSE_LEFT);
      Serial.print(mouseState);
    } else if (strcmp(cmd, "MSR") == 0) {
      mouseState = Mouse.isPressed(MOUSE_RIGHT);
      Serial.print(mouseState);
    } else if (strcmp(cmd, "MSM") == 0) {
      mouseState = Mouse.isPressed(MOUSE_MIDDLE);
      Serial.print(mouseState);
    } else if (strcmp(cmd, "MMV") == 0) {
      num = 0;
      inChar = Serial.read();
      i = inChar - 0x30;
      if (i == -3) {
        isMinus = 1;
        inChar = Serial.read();
        i = inChar - 0x30;
      } else {
        isMinus = 0;
      }
      while (i >= 0 && i <= 9) {
        if (isMinus) {
          num = (num * 10) - i;
        } else {
          num = (num * 10) + i;
        }
        inChar = Serial.read();
        i = inChar - 0x30;
      }
      xReading = num;

      num = 0;
      inChar = Serial.read();
      i = inChar - 0x30;
      if (i == -3) {
        isMinus = 1;
        inChar = Serial.read();
        i = inChar - 0x30;
      } else {
        isMinus = 0;
      }
      while (i >= 0 && i <= 9) {
        if (isMinus) {
          num = (num * 10) - i;
        } else {
          num = (num * 10) + i;
        }
        inChar = Serial.read();
        i = inChar - 0x30;
      }
      yReading = num;

      num = 0;
      inChar = Serial.read();
      i = inChar - 0x30;
      if (i == -3) {
        isMinus = 1;
        inChar = Serial.read();
        i = inChar - 0x30;
      } else {
        isMinus = 0;
      }
      while (i >= 0 && i <= 9) {
        if (isMinus) {
          num = (num * 10) - i;
        } else {
          num = (num * 10) + i;
        }
        inChar = Serial.read();
        i = inChar - 0x30;
      }
      wReading = num;

      if (moveDelta < xReading) {
        while (moveDelta < xReading) {
          Mouse.move(moveDelta, 0, 0);
          xReading = xReading - moveDelta;
        }
      } else if (xReading < -moveDelta) {
        while (xReading < -moveDelta) {
          Mouse.move(-moveDelta, 0, 0);
          xReading = xReading + moveDelta;
        }
      }
      Mouse.move(xReading, 0, 0);

      if (moveDelta < yReading) {
        while (moveDelta < yReading) {
          Mouse.move(0, moveDelta, 0);
          yReading = yReading - moveDelta;
        }
      } else if (yReading < -moveDelta) {
        while (yReading < -moveDelta) {
          Mouse.move(0, -moveDelta, 0);
          yReading = yReading + moveDelta;
        }
      }
      Mouse.move(0, yReading, 0);

      if (moveDelta < wReading) {
        while (moveDelta < wReading) {
          Mouse.move(0, 0, moveDelta);
          wReading = wReading - moveDelta;
        }
      } else if (wReading < -moveDelta) {
        while (wReading < -moveDelta) {
          Mouse.move(0, 0, -moveDelta);
          wReading = wReading + moveDelta;
        }
      }
      Mouse.move(0, 0, wReading);
    } else if (strcmp(cmd, "KPS") == 0) {
      inChar = Serial.read();
      Keyboard.press(inChar);
    } else if (strcmp(cmd, "KPN") == 0) {
      inChar = Serial.read();
      keyboardState = Keyboard.print(char(inChar));
      Serial.print(keyboardState);
    } else if (strcmp(cmd, "KPL") == 0) {
      inChar = Serial.read();
      keyboardState = Keyboard.println(char(inChar));
      Serial.println(keyboardState);
    } else if (strcmp(cmd, "KRL") == 0) {
      inChar = Serial.read();
      keyboardState = Keyboard.release(inChar);
      Serial.print(keyboardState);
    } else if (strcmp(cmd, "KRA") == 0) {
      Keyboard.releaseAll();
      Serial.print(keyboardState);
    } else if (strcmp(cmd, "KWR") == 0) {
      inChar = Serial.read();
      keyboardState = Keyboard.write(inChar);
      Serial.print(keyboardState);
    }
  }
}
